/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'blastxml2.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/blastxml2/Results.hpp>
#include <objects/blastxml2/Iteration.hpp>
#include <objects/blastxml2/Search.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

BEGIN_blastxml2_SCOPE // namespace ncbi::objects::blastxml2::


// generated classes

void CResults_Base::Reset(void)
{
    if ( m_choice != e_not_set )
        ResetSelection();
}

void CResults_Base::ResetSelection(void)
{
    switch ( m_choice ) {
    case e_Iterations:
        m_Iterations.Destruct();
        break;
    case e_Bl2seq:
        m_Bl2seq.Destruct();
        break;
    case e_Search:
        m_object->RemoveReference();
        break;
    default:
        break;
    }
    m_choice = e_not_set;
}

void CResults_Base::DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    switch ( index ) {
    case e_Iterations:
        m_Iterations.Construct();
        break;
    case e_Search:
        (m_object = new(pool) ncbi::objects::blastxml2::CSearch())->AddReference();
        break;
    case e_Bl2seq:
        m_Bl2seq.Construct();
        break;
    default:
        break;
    }
    m_choice = index;
}

const char* const CResults_Base::sm_SelectionNames[] = {
    "not set",
    "iterations",
    "search",
    "bl2seq"
};

NCBI_NS_STD::string CResults_Base::SelectionName(E_Choice index)
{
    return NCBI_NS_NCBI::CInvalidChoiceSelection::GetName(index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

void CResults_Base::ThrowInvalidSelection(E_Choice index) const
{
    throw NCBI_NS_NCBI::CInvalidChoiceSelection(DIAG_COMPILE_INFO, this, m_choice, index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

const CResults_Base::TSearch& CResults_Base::GetSearch(void) const
{
    CheckSelected(e_Search);
    return *static_cast<const TSearch*>(m_object);
}

CResults_Base::TSearch& CResults_Base::SetSearch(void)
{
    Select(e_Search, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TSearch*>(m_object);
}

void CResults_Base::SetSearch(CResults_Base::TSearch& value)
{
    TSearch* ptr = &value;
    if ( m_choice != e_Search || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Search;
    }
}

// helper methods

// type info
BEGIN_NAMED_BASE_CHOICE_INFO("Results", CResults)
{
    SET_CHOICE_MODULE("NCBI-BlastOutput");
    ADD_NAMED_BUF_CHOICE_VARIANT("iterations", m_Iterations, STL_list, (STL_CRef, (CLASS, (CIteration))));
    ADD_NAMED_REF_CHOICE_VARIANT("search", m_object, CSearch);
    ADD_NAMED_BUF_CHOICE_VARIANT("bl2seq", m_Bl2seq, STL_list, (STL_CRef, (CLASS, (CSearch))));
}
END_CHOICE_INFO

// constructor
CResults_Base::CResults_Base(void)
    : m_choice(e_not_set)
{
}

// destructor
CResults_Base::~CResults_Base(void)
{
    Reset();
}



END_blastxml2_SCOPE // namespace ncbi::objects::blastxml2::

END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

