/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'blastxml2.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/blastxml2/Search.hpp>
#include <objects/blastxml2/Hit.hpp>
#include <objects/blastxml2/Range.hpp>
#include <objects/blastxml2/Statistics.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

BEGIN_blastxml2_SCOPE // namespace ncbi::objects::blastxml2::


// generated classes

void CSearch_Base::ResetQuery_id(void)
{
    m_Query_id.erase();
    m_set_State[0] &= ~0x3;
}

void CSearch_Base::ResetQuery_title(void)
{
    m_Query_title.erase();
    m_set_State[0] &= ~0xc;
}

void CSearch_Base::ResetQuery_masking(void)
{
    m_Query_masking.clear();
    m_set_State[0] &= ~0xc0;
}

void CSearch_Base::ResetHits(void)
{
    m_Hits.clear();
    m_set_State[0] &= ~0x300;
}

void CSearch_Base::ResetStat(void)
{
    m_Stat.Reset();
}

void CSearch_Base::SetStat(CSearch_Base::TStat& value)
{
    m_Stat.Reset(&value);
}

CSearch_Base::TStat& CSearch_Base::SetStat(void)
{
    if ( !m_Stat )
        m_Stat.Reset(new ncbi::objects::blastxml2::CStatistics());
    return (*m_Stat);
}

void CSearch_Base::ResetMessage(void)
{
    m_Message.erase();
    m_set_State[0] &= ~0x3000;
}

void CSearch_Base::Reset(void)
{
    ResetQuery_id();
    ResetQuery_title();
    ResetQuery_len();
    ResetQuery_masking();
    ResetHits();
    ResetStat();
    ResetMessage();
}

BEGIN_NAMED_BASE_CLASS_INFO("Search", CSearch)
{
    SET_CLASS_MODULE("NCBI-BlastOutput");
    ADD_NAMED_STD_MEMBER("query-id", m_Query_id)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("query-title", m_Query_title)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("query-len", m_Query_len)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("query-masking", m_Query_masking, STL_list, (STL_CRef, (CLASS, (CRange))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("hits", m_Hits, STL_list, (STL_CRef, (CLASS, (CHit))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_REF_MEMBER("stat", m_Stat, CStatistics)->SetOptional();
    ADD_NAMED_STD_MEMBER("message", m_Message)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
}
END_CLASS_INFO

// constructor
CSearch_Base::CSearch_Base(void)
    : m_Query_len(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CSearch_Base::~CSearch_Base(void)
{
}



END_blastxml2_SCOPE // namespace ncbi::objects::blastxml2::

END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

